searchData={"content_type":"text/markdown","items":[{"doc":"[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"ExToolkit.html","title":"ExToolkit","type":"module"},{"doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.9.11\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"ExToolkit.html#module-installation","title":"Installation - ExToolkit","type":"module"},{"doc":"Utility for quick and simple benchmarking functions in Elixir.","ref":"ExToolkit.Bench.html","title":"ExToolkit.Bench","type":"module"},{"doc":"Benchmarks the execution time of a piece of code. It should be used only in\nreally simple cases.","ref":"ExToolkit.Bench.html#timeit/2","title":"ExToolkit.Bench.timeit/2","type":"macro"},{"doc":"iex> timeit \"Sleep for a while\", do: :timer.sleep(1000)\n  Executed Sleep for a while in 1.00 seconds","ref":"ExToolkit.Bench.html#timeit/2-examples","title":"Examples - ExToolkit.Bench.timeit/2","type":"macro"},{"doc":"Helper functions that extend `Ecto.Changeset` functionality.","ref":"ExToolkit.Ecto.Changeset.html","title":"ExToolkit.Ecto.Changeset","type":"module"},{"doc":"Validates the structure of a URL field in an Ecto changeset. It does not make it required field.\n\nIf the `field` in the `changeset` is a URL, this function ensures that it has a scheme (defaulting to \"https://\" if\nnone is present), and then checks the URL's structure against a regular expression.\n\nIf the URL's structure is invalid, the `error_message` is attached to the `field` in the `changeset`'s errors.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3","title":"ExToolkit.Ecto.Changeset.validate_url/3","type":"function"},{"doc":"- `changeset`: The Ecto changeset containing the URL to validate.\n  - `field`: The key (atom) for the field in the changeset containing the URL.\n  - `error_message`: The error message to attach to the `field` in the `changeset` if the URL is invalid.","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-parameters","title":"Parameters - ExToolkit.Ecto.Changeset.validate_url/3","type":"function"},{"doc":"iex> types = %{url: :string}\n    iex> params = %{url: \"https://www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"www.example.com/\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: nil}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"some@invalid_url\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset \n\n    iex> types = %{url: :string}\n    iex> params = %{url: \"Just some random text\"}\n    iex> Ecto.Changeset.cast({%{}, types}, params, Map.keys(types))\n    ...> |> validate_url(:url, \"is not a valid url\")\n    #Ecto.Changeset","ref":"ExToolkit.Ecto.Changeset.html#validate_url/3-examples","title":"Examples - ExToolkit.Ecto.Changeset.validate_url/3","type":"function"},{"doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.ObjectID.html","title":"ExToolkit.Ecto.ObjectID","type":"module"},{"doc":"@primary_key {:id, ExToolkit.Ecto.ObjectID, prefix: \"user\", autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.ObjectID","ref":"ExToolkit.Ecto.ObjectID.html#module-examples","title":"Examples - ExToolkit.Ecto.ObjectID","type":"module"},{"doc":"- https://dev.to/stripe/designing-apis-for-humans-object-ids-3o5a\n  - https://danschultzer.com/posts/prefixed-base62-uuidv7-object-ids-with-ecto","ref":"ExToolkit.Ecto.ObjectID.html#module-resources","title":"Resources - ExToolkit.Ecto.ObjectID","type":"module"},{"doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:opts/0","title":"ExToolkit.Ecto.ObjectID.opts/0","type":"type"},{"doc":"","ref":"ExToolkit.Ecto.ObjectID.html#t:t/0","title":"ExToolkit.Ecto.ObjectID.t/0","type":"type"},{"doc":"A helper module that extend `Ecto.Query` functionality.","ref":"ExToolkit.Ecto.Query.html","title":"ExToolkit.Ecto.Query","type":"module"},{"doc":"","ref":"ExToolkit.Ecto.Query.html#apply_filters/2","title":"ExToolkit.Ecto.Query.apply_filters/2","type":"function"},{"doc":"Applies a series of operations to an Ecto query.","ref":"ExToolkit.Ecto.Query.html#apply_options/2","title":"ExToolkit.Ecto.Query.apply_options/2","type":"function"},{"doc":"- `query`: The Ecto query to which operations should be applied.\n- `opts`: A list of operations to apply. Each operation is a tuple where the first element is the operation name\n  and the second element is the value to use for that operation.\n\nThe following operations are supported:\n\n- `{:where, filters}`: Adds a `where` clause to the query.\n- `{:select, fields}`: Adds a `select` clause to the query.\n- `{:order_by, criteria}`: Adds an `order_by` clause to the query.\n- `{:limit, criteria}`: Adds a `limit` clause to the query.\n- `{:preload, preload}`: Adds a `preload` clause to the query.\n\nInvalid options are ignored from query result.","ref":"ExToolkit.Ecto.Query.html#apply_options/2-parameters","title":"Parameters - ExToolkit.Ecto.Query.apply_options/2","type":"function"},{"doc":"iex> query = from(u in \"users\")\n    iex> apply_options(query, where: [age: 18], select: [:id, :email])\n    #Ecto.Query \n\n    iex> query = from(u in \"users\")\n    iex> filters = [\n    ...> {:where, [age: 18]},\n    ...> {:order_by, [desc: :age]},\n    ...> {:select, [:id, :email]},\n    ...> {:limit, 10},\n    ...> {:preload, :posts},\n    ...>]\n    iex> apply_options(query, filters)\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_options/2-examples","title":"Examples - ExToolkit.Ecto.Query.apply_options/2","type":"function"},{"doc":"Applies pagination to an Ecto query. It calculates the correct offset based on the page number and limits the number\nof results returned by the query to the specified page size.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3","title":"ExToolkit.Ecto.Query.apply_pagination/3","type":"function"},{"doc":"- `query` - An Ecto.Query or any data structure implementing the `Ecto.Queryable` protocol.\n  - `page` - The page number for which data is requested. Can be a positive integer or a string representing an integer.\n  - `page_size` - The number of items to be included on each page. Can be a positive integer or a string representing an integer.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-parameters","title":"Parameters - ExToolkit.Ecto.Query.apply_pagination/3","type":"function"},{"doc":"- An `Ecto.Queryable.t()` with pagination applied.\n\nThis function supports page and page_size values passed as integers or strings. If strings are provided, they are\nconverted to integers. If the conversion is not possible, an error will occur.","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-returns","title":"Returns - ExToolkit.Ecto.Query.apply_pagination/3","type":"function"},{"doc":"iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 1, 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, \"2\", 20)\n    #Ecto.Query \n\n    iex> query = from(u in \"users\", select: u.id)\n    iex> apply_pagination(query, 4, \"15\")\n    #Ecto.Query","ref":"ExToolkit.Ecto.Query.html#apply_pagination/3-examples","title":"Examples - ExToolkit.Ecto.Query.apply_pagination/3","type":"function"},{"doc":"Filters a query to only include rows where the specified column's value is within a provided range.","ref":"ExToolkit.Ecto.Query.html#in_range/3","title":"ExToolkit.Ecto.Query.in_range/3","type":"function"},{"doc":"- `query`: The Ecto query to filter.\n- `column`: The column on which to apply the range filter.\n- `min..max`: The range of values to filter on.","ref":"ExToolkit.Ecto.Query.html#in_range/3-parameters","title":"Parameters - ExToolkit.Ecto.Query.in_range/3","type":"function"},{"doc":"iex> query = from(u in \"users\", select: u.age)\n    iex> in_range(query, :age, 18..30)\n    #Ecto.Query = ^18 and u0.age <= ^30, select: u0.age>","ref":"ExToolkit.Ecto.Query.html#in_range/3-examples","title":"Examples - ExToolkit.Ecto.Query.in_range/3","type":"function"},{"doc":"","ref":"ExToolkit.Ecto.Query.html#t:option/0","title":"ExToolkit.Ecto.Query.option/0","type":"type"},{"doc":"","ref":"ExToolkit.Ecto.Query.html#t:options/0","title":"ExToolkit.Ecto.Query.options/0","type":"type"},{"doc":"","ref":"ExToolkit.Ecto.Query.html#sanitize_options/1","title":"ExToolkit.Ecto.Query.sanitize_options/1","type":"function"},{"doc":"A Ecto type that facilitates the generation of prefixed base62 encoded UUIDv7\nfor use as primary and foreign keys in Ecto schemas.","ref":"ExToolkit.Ecto.SlugID.html","title":"ExToolkit.Ecto.SlugID","type":"module"},{"doc":"@primary_key {:id, ExToolkit.Ecto.SlugID, autogenerate: true}\n    @foreign_key_type ExToolkit.Ecto.SlugID","ref":"ExToolkit.Ecto.SlugID.html#module-examples","title":"Examples - ExToolkit.Ecto.SlugID","type":"module"},{"doc":"","ref":"ExToolkit.Ecto.SlugID.html#generate/0","title":"ExToolkit.Ecto.SlugID.generate/0","type":"function"},{"doc":"","ref":"ExToolkit.Ecto.SlugID.html#t:t/0","title":"ExToolkit.Ecto.SlugID.t/0","type":"type"},{"doc":"A utility module providing functions to encode and decode UUIDs using Base62 encoding.\n\nThe Base62 encoding allows representing UUIDs in a more compact form, reducing their length from 32 to 22 characters.\nThis module supports converting standard UUIDs (as strings) to Base62 encoded UUIDs and vice-versa.","ref":"ExToolkit.Encode.Base62UUID.html","title":"ExToolkit.Encode.Base62UUID","type":"module"},{"doc":"Gets @base62_uuid_length.","ref":"ExToolkit.Encode.Base62UUID.html#base62_uuid_length/0","title":"ExToolkit.Encode.Base62UUID.base62_uuid_length/0","type":"function"},{"doc":"iex> Elixir.ExToolkit.Encode.Base62UUID.base62_uuid_length()\n    22","ref":"ExToolkit.Encode.Base62UUID.html#base62_uuid_length/0-examples","title":"Examples - ExToolkit.Encode.Base62UUID.base62_uuid_length/0","type":"function"},{"doc":"Decodes a Base62 encoded string into a UUID.\n\nThis function is the inverse of `encode/1`. It converts a Base62 encoded string back to its original UUID form.","ref":"ExToolkit.Encode.Base62UUID.html#decode/1","title":"ExToolkit.Encode.Base62UUID.decode/1","type":"function"},{"doc":"iex> Base62UUID.decode(\"2FJ5BAFmLzL78YNqBSsS9I\")\n    {:ok, \"49d3793a-2f87-4bcb-aa96-be5892848ae0\"}","ref":"ExToolkit.Encode.Base62UUID.html#decode/1-examples","title":"Examples - ExToolkit.Encode.Base62UUID.decode/1","type":"function"},{"doc":"Encodes a UUID into a Base62 encoded string.","ref":"ExToolkit.Encode.Base62UUID.html#encode/1","title":"ExToolkit.Encode.Base62UUID.encode/1","type":"function"},{"doc":"iex> Base62UUID.encode(\"49d3793a-2f87-4bcb-aa96-be5892848ae0\")\n    \"2FJ5BAFmLzL78YNqBSsS9I\"","ref":"ExToolkit.Encode.Base62UUID.html#encode/1-examples","title":"Examples - ExToolkit.Encode.Base62UUID.encode/1","type":"function"},{"doc":"Gets @uuid_length.","ref":"ExToolkit.Encode.Base62UUID.html#uuid_length/0","title":"ExToolkit.Encode.Base62UUID.uuid_length/0","type":"function"},{"doc":"iex> Elixir.ExToolkit.Encode.Base62UUID.uuid_length()\n    32","ref":"ExToolkit.Encode.Base62UUID.html#uuid_length/0-examples","title":"Examples - ExToolkit.Encode.Base62UUID.uuid_length/0","type":"function"},{"doc":"This module provides utility functions for interacting with Git.","ref":"ExToolkit.Git.html","title":"ExToolkit.Git","type":"module"},{"doc":"Retrieves the current Git revision hash.","ref":"ExToolkit.Git.html#revision_hash/0","title":"ExToolkit.Git.revision_hash/0","type":"function"},{"doc":"Basic language primitives to ease development flow.","ref":"ExToolkit.Kernel.html","title":"ExToolkit.Kernel","type":"module"},{"doc":"Defines a module attribute and a function to get it. Inspired by `attr_reader`\nfrom ruby.","ref":"ExToolkit.Kernel.html#defattr/1","title":"ExToolkit.Kernel.defattr/1","type":"macro"},{"doc":"iex> defmodule ExampleModule do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr foo: :bar\n    ...> end\n    iex> ExampleModule.foo()\n    :bar\n\n    iex> defmodule ExampleModule2 do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr name: \"ExToolkit\", version: \"1.0.0\"\n    ...> end\n    iex> %{name: ExampleModule2.name(), version: ExampleModule2.version()}\n    %{name: \"ExToolkit\", version: \"1.0.0\"}\n\n    iex> defmodule ExampleModule3 do\n    ...>   require ExToolkit.Kernel\n    ...>   defattr [version: Version.parse!(\"1.0.1\")]\n    ...> end\n    iex> ExampleModule3.version()\n    %Version{major: 1, minor: 0, patch: 1}","ref":"ExToolkit.Kernel.html#defattr/1-examples","title":"Examples - ExToolkit.Kernel.defattr/1","type":"macro"},{"doc":"Returns the atom `:error`.","ref":"ExToolkit.Kernel.html#error/0","title":"ExToolkit.Kernel.error/0","type":"function"},{"doc":"iex> error()\n    :error","ref":"ExToolkit.Kernel.html#error/0-example","title":"Example - ExToolkit.Kernel.error/0","type":"function"},{"doc":"Wraps a given value in a tuple tagged with `:error`.","ref":"ExToolkit.Kernel.html#error/1","title":"ExToolkit.Kernel.error/1","type":"function"},{"doc":"iex> error(\"something went wrong\")\n    {:error, \"something went wrong\"}\n\n    iex> error(404)\n    {:error, 404}","ref":"ExToolkit.Kernel.html#error/1-examples","title":"Examples - ExToolkit.Kernel.error/1","type":"function"},{"doc":"Wraps a given value in a tuple tagged with `:noreply`.","ref":"ExToolkit.Kernel.html#noreply/1","title":"ExToolkit.Kernel.noreply/1","type":"function"},{"doc":"iex> noreply(\"something went wrong\")\n    {:noreply, \"something went wrong\"}\n\n    iex> noreply(404)\n    {:noreply, 404}","ref":"ExToolkit.Kernel.html#noreply/1-examples","title":"Examples - ExToolkit.Kernel.noreply/1","type":"function"},{"doc":"Returns the atom `:ok`.","ref":"ExToolkit.Kernel.html#ok/0","title":"ExToolkit.Kernel.ok/0","type":"function"},{"doc":"iex> ok()\n    :ok","ref":"ExToolkit.Kernel.html#ok/0-example","title":"Example - ExToolkit.Kernel.ok/0","type":"function"},{"doc":"Wraps a given value in a tuple tagged with `:ok`.","ref":"ExToolkit.Kernel.html#ok/1","title":"ExToolkit.Kernel.ok/1","type":"function"},{"doc":"iex> ok(42)\n    {:ok, 42}\n\n    iex> ok(\"hello\")\n    {:ok, \"hello\"}","ref":"ExToolkit.Kernel.html#ok/1-examples","title":"Examples - ExToolkit.Kernel.ok/1","type":"function"},{"doc":"","ref":"ExToolkit.Kernel.html#t:type/0","title":"ExToolkit.Kernel.type/0","type":"type"},{"doc":"Determines the type of the given term.","ref":"ExToolkit.Kernel.html#type_of/1","title":"ExToolkit.Kernel.type_of/1","type":"function"},{"doc":"iex> type_of(3.14)\n    :float\n\n    iex> type_of(42)\n    :integer\n\n    iex> type_of(true)\n    :boolean\n\n    iex> type_of(:atom)\n    :atom\n\n    iex> type_of(\"string\")\n    :binary\n\n    iex> type_of([1, 2, 3])\n    :list\n\n    iex> type_of({:ok, 1})\n    :tuple\n\n    iex> type_of(%{})\n    :map\n\n    iex> type_of(fn -> :ok end)\n    :function\n\n    iex> type_of(%URI{})\n    :struct\n\n    iex> type_of(%RuntimeError{})\n    :exception\n\n    iex> type_of(self())\n    :pid\n\n    iex> type_of(nil)\n    nil","ref":"ExToolkit.Kernel.html#type_of/1-examples","title":"Examples - ExToolkit.Kernel.type_of/1","type":"function"},{"doc":"Validates the given options against the given defaults.","ref":"ExToolkit.Kernel.html#validate_opts!/2","title":"ExToolkit.Kernel.validate_opts!/2","type":"function"},{"doc":"iex> validate_opts!([foo: :bar], [foo: :baz])\n    %{foo: :bar}\n\n    iex> validate_opts!([], [foo: :baz])\n    %{foo: :baz}\n\n    iex> validate_opts!([foo: :bar, bar: :baz], %{foo: :bar})\n    ** (ArgumentError) unknown keys [:bar] in [foo: :bar, bar: :baz], the allowed keys are: [:foo]\n\n    iex> validate_opts!(%{foo: :bar, bar: :baz}, %{foo: :bar, bar: :baz})\n    %{foo: :bar, bar: :baz}\n\n    iex> validate_opts!(%{foo: :bar}, [foo: :bar])\n    %{foo: :bar}\n\n    iex> validate_opts!(%{foo: :bar}, [foo: :baz, bar: :zad])\n    %{foo: :bar, bar: :zad}","ref":"ExToolkit.Kernel.html#validate_opts!/2-examples","title":"Examples - ExToolkit.Kernel.validate_opts!/2","type":"function"},{"doc":"This module encapsulates common tasks related to processing personal names in\na standardized format. This module treats names as case-insensitive and\nreturns results in a formatted, readable way.","ref":"ExToolkit.Naming.html","title":"ExToolkit.Naming","type":"module"},{"doc":"Capitalizes the first letter of each word in a name.","ref":"ExToolkit.Naming.html#capitalize/1","title":"ExToolkit.Naming.capitalize/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#capitalize/1-arguments","title":"Arguments - ExToolkit.Naming.capitalize/1","type":"function"},{"doc":"iex> Naming.capitalize(nil)\n    \"\"\n\n    iex> Naming.capitalize(\"\")\n    \"\"\n\n    iex> Naming.capitalize(\"john doe\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"JOHN DOE\")\n    \"John Doe\"\n\n    iex> Naming.capitalize(\"john nommensen duchac\")\n    \"John Nommensen Duchac\"","ref":"ExToolkit.Naming.html#capitalize/1-examples","title":"Examples - ExToolkit.Naming.capitalize/1","type":"function"},{"doc":"Extracts and capitalizes the first and last names from a given name.","ref":"ExToolkit.Naming.html#extract_first_last_name/1","title":"ExToolkit.Naming.extract_first_last_name/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_first_last_name/1-arguments","title":"Arguments - ExToolkit.Naming.extract_first_last_name/1","type":"function"},{"doc":"iex> Naming.extract_first_last_name(nil)\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"\")\n    \"\"\n\n    iex> Naming.extract_first_last_name(\"john\")\n    \"John\"\n\n    iex> Naming.extract_first_last_name(\"john doe smith\")\n    \"John Smith\"","ref":"ExToolkit.Naming.html#extract_first_last_name/1-examples","title":"Examples - ExToolkit.Naming.extract_first_last_name/1","type":"function"},{"doc":"Extracts the initials from a given name.\n\nThis function takes a name (a string of one or more words), and extracts the\nfirst letter of the first name and the family name.","ref":"ExToolkit.Naming.html#extract_initials/1","title":"ExToolkit.Naming.extract_initials/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_initials/1-arguments","title":"Arguments - ExToolkit.Naming.extract_initials/1","type":"function"},{"doc":"iex> Naming.extract_initials(nil)\n    \"\"\n\n    iex> Naming.extract_initials(\"\")\n    \"\"\n\n    iex> Naming.extract_initials(\"John\")\n    \"J\"\n\n    iex> Naming.extract_initials(\"John Doe\")\n    \"JD\"\n\n    iex> Naming.extract_initials(\"John Nommensen Duchac\")\n    \"JD\"","ref":"ExToolkit.Naming.html#extract_initials/1-examples","title":"Examples - ExToolkit.Naming.extract_initials/1","type":"function"},{"doc":"Extracts and capitalizes the first and last names and then shortens the first name from a given name and.","ref":"ExToolkit.Naming.html#extract_short_name/1","title":"ExToolkit.Naming.extract_short_name/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#extract_short_name/1-arguments","title":"Arguments - ExToolkit.Naming.extract_short_name/1","type":"function"},{"doc":"iex> Naming.extract_short_name(nil)\n    \"\"\n\n    iex> Naming.extract_short_name(\"\")\n    \"\"\n\n    iex> Naming.extract_short_name(\"john\")\n    \"John\"\n\n    iex> Naming.extract_short_name(\"john doe smith\")\n    \"J. Smith\"\n\n    iex> Naming.extract_short_name(\"john doe smith (funny)\")\n    \"J. Smith\"","ref":"ExToolkit.Naming.html#extract_short_name/1-examples","title":"Examples - ExToolkit.Naming.extract_short_name/1","type":"function"},{"doc":"Shortens the first name to its initial, while preserving the rest of the name.\n\nThis function takes a name (a string of one or more words), and reduces the first name to its initial.\nThe rest of the name is preserved. The initial is followed by a period and a space, and then the rest of the name.","ref":"ExToolkit.Naming.html#shorten_firstname/1","title":"ExToolkit.Naming.shorten_firstname/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#shorten_firstname/1-arguments","title":"Arguments - ExToolkit.Naming.shorten_firstname/1","type":"function"},{"doc":"iex> Naming.shorten_firstname(nil)\n    \"\"\n\n    iex> Naming.shorten_firstname(\"\")\n    \"\"\n\n    iex> Naming.shorten_firstname(\"John\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"john\")\n    \"J.\"\n\n    iex> Naming.shorten_firstname(\"John Doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe\")\n    \"J. Doe\"\n\n    iex> Naming.shorten_firstname(\"john doe jr\")\n    \"J. Doe Jr\"","ref":"ExToolkit.Naming.html#shorten_firstname/1-examples","title":"Examples - ExToolkit.Naming.shorten_firstname/1","type":"function"},{"doc":"Shortens the last name to its initial, while preserving the rest of the name.\n\nThis function takes a name (a string of one or more words), and reduces the last name to its initial.\nThe rest of the name is preserved. The initial is followed by a period and a space.","ref":"ExToolkit.Naming.html#shorten_lastname/1","title":"ExToolkit.Naming.shorten_lastname/1","type":"function"},{"doc":"- `name`: A string representing a full name, or `nil`.","ref":"ExToolkit.Naming.html#shorten_lastname/1-arguments","title":"Arguments - ExToolkit.Naming.shorten_lastname/1","type":"function"},{"doc":"iex> Naming.shorten_lastname(nil)\n    \"\"\n\n    iex> Naming.shorten_lastname(\"\")\n    \"\"\n\n    iex> Naming.shorten_lastname(\"John\")\n    \"John\"\n\n    iex> Naming.shorten_lastname(\"john\")\n    \"John\"\n\n    iex> Naming.shorten_lastname(\"John Doe\")\n    \"John D.\"\n\n    iex> Naming.shorten_lastname(\"John Van Doe\")\n    \"John Van D.\"\n\n    iex> Naming.shorten_lastname(\"john doe\")\n    \"John D.\"","ref":"ExToolkit.Naming.html#shorten_lastname/1-examples","title":"Examples - ExToolkit.Naming.shorten_lastname/1","type":"function"},{"doc":"# Elixir Toolkit\n\n[![hex.pm](https://img.shields.io/hexpm/v/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/dt/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![hex.pm](https://img.shields.io/hexpm/l/ex_toolkit.svg)](https://hex.pm/packages/ex_toolkit)\n[![github.com](https://img.shields.io/github/last-commit/marmelasoft/ex_toolkit.svg)](https://github.com/marmelasoft/ex_toolkit)\n\n`ExToolkit` is a collection of Elixir helpers that offers pre-built effective\nrecipes for common needs when developing most applications.","ref":"readme.html","title":"Elixir Toolkit","type":"extras"},{"doc":"The package can be installed by adding `ex_toolkit` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_toolkit, \"~> 0.9.13\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation","title":"Installation - Elixir Toolkit","type":"extras"}],"producer":{"name":"ex_doc","version":"0.36.1"},"proglang":"elixir"}